# Create a bulk job Creates a new bulk job. The job type can be one of Import, Delete, Update, or Cancel. The response includes the job ID and information needed to upload your data file to S3. ### Next Step: Upload the File to S3 After creating a bulk job, you must upload the data file to Amazon S3 using the information returned in the uploadFileInfo object. This includes: - uploadUrl: The S3 endpoint to which the file must be uploaded. - formFields: Key-value pairs to include in a multipart/form-data POST request. - jobId: The ID of the job, used for later submission. You can use the following cURL command to upload the file: curl --request POST \ --url '' \ --header 'Content-Type: multipart/form-data' \ --form 'key=' \ --form 'bucket=' \ --form 'x-amz-algorithm=' \ --form 'x-amz-credential=' \ --form 'x-amz-date=' \ --form 'Policy=' \ --form 'x-amz-signature=' \ --form 'x-amz-security-token=' \ --form 'file=@/path/to/your/file.csv' Note: Always use the exact form field keys returned in the formFields object of the API response. This is a presigned Amazon S3 POST operation and not a Zuora endpoint. After uploading the file, you must call the "Submit a bulk job for processing" operation endpoint to start processing the job. Endpoint: POST /bulk-data/bulk-jobs Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). ## Request fields (application/json): - `name` (string, required) Name of the job. Max length is 255 characters - `objectType` (string, required) Type of the object. Supported object types: - account - accountingcode - accountingperiod - amendment - bill-run - bill-run-batches - bill-run-filters - contact - credit-memo - credit-memo-from-charge - credit-memo-from-invoice - debit-memo - debit-memo-from-charge - debit-memo-from-invoice - invoice - journal-entry - journal-run - offer - omni-channel-subscription - order - order-create-order-line-item - order-create-subscription-existing-account - order-create-subscription-existing-account-with-volume-charge - order-create-subscription-with-new-account - order-remove-product - order-update-subscription-add-product - order-update-subscription-change-plan - order-update-subscription-price-quantity-change - payment - payment-profile - payment-schedule - payment-schedule-item - payments-simple - payments-unapply - price-book-item - product - product-charge-definition - product-rate-plan - product-rate-plan-charge - product-rate-plan-charge-tier - product-rate-plan-definition - refund - revenue-accounting-code - subscription - subscription-add-rate-plan - subscription-change-rate-plan - subscription-remove-rate-plan - subscription-update-rate-plan - taxation-item - unitofmeasure - usage - `description` (string) Short description of the job. Max length is 255 characters - `mappings` (array) List of mappings. Each mapping maps a source field to a target field in the object. If the field is an array, the type and arrayType must be specified. - `mappings.source` (string, required) Source field name - `mappings.target` (string, required) Target field name. Note: The target field must not contain spaces, dots (.), underscores (_), or asterisks (*). - `mappings.type` (string) Field type Enum: "array", "string", "number", "boolean" - `mappings.arrayType` (string) Type of objects in the array if the field is an array type Enum: "string", "number", "boolean" - `headers` (array) List of headers in the source file. Required if the source file does not have a header row. - `rowIdHeader` (string) Header in the source file that contains the row id. - `delimiter` (string) Delimiter used in the source file. Default is comma. Supported values: comma, tab, pipe, semicolon, colon, caret, tilde, dot/period - `hasHeaders` (boolean) Indicates if the source file has a header row. Default is false - `fileType` (string) Type of the source file. Supported values: csv, jsonl Default is csv, which means delimited file where the delimiter can be comma but can also be one of the other supported delimiters Enum: "csv", "jsonl" - `jobType` (string) Type of the bulk job being created. Default is IMPORT Enum: "Import", "Delete", "Update", "Cancel" - `isCustomObject` (boolean) Indicates if the object type is a custom object. Default is false - `customObjectNamespace` (string) Namespace of the custom object. Applicable only when isCustomObject is true. Default namespace is 'default'. ## Response 200 fields (application/json): - `id` (string) Unique identifier for the job - `uploadUrl` (string) URL to upload the file. This is the URL to which the file should be uploaded using a PUT request. - `uploadRequest` (object) - `uploadRequest.uri` (string) URL to which the file must be uploaded. - `uploadRequest.fields` (object) Form fields required to complete the S3 file upload. - `status` (string) Status of the job Enum: "Created", "Submitted", "In Progress", "Aborting", "Completed", "Failed", "Aborted", "Cancelled", "Downloading" - `jobType` (string) Type of the job Enum: "Import", "Delete", "Update", "Cancel"